﻿
transform phone_crop:
    crop(0,0,600,700)

init python:
    class phone_contact:
        def __init__(self, id, name = None, number = None, sms = []):
            self.id = id
            self.name = name
            self.number = number
            self.sms = sms

    class phone_class:
        def __init__(self, owner, id):
            self.id = id
            self.owner = owner
            self.history = []
            self.active = None
            self.stat = "Closed"
            self.contacts = []
            self.typing = ""
            self.current = None
            self.times = None
            self.phase = 0
        def sms(self, sender, message, times):
            self.current = [sender, message]
            if times:
                self.times = times
            else:
                self.times = [500, len(message)*40, 500]
            self.phase = 0
            renpy.pause(hard=True)

        def add(self, id, name = None, number = None):
            for i in self.contacts:
                if i.id == sender:
                    if name:
                        i.name = name
                    if number:
                        i.number = number
            else:
                self.contacts.append(phone_contact(id, name, number))
        def open(self, sender):
            for i in self.contacts:
                if i.id == sender:
                    self.active = i

        def close(self):
            self.active = None
        def tick(self):
            if len(self.times):
                if self.current[0] == self.id:
                    if self.phase == 0:
                        if self.times[0] <= 0:
                            self.times.pop(0)
                            self.phase = 2
                        else:
                            self.times[0] -= 100
                    else:
                        if len(self.current[1]) == len(self.typing):
                            self.times.pop(0)
                            self.phase = 0
                            self.typing = ""
                        else:
                            self.typing += self.current[1][len(self.typing)]
                else:
                    if self.phase == 0:
                        if self.times[0] <= 0:
                            self.times.pop(0)
                            self.phase = 1
                        else:
                            self.times[0] -= 100
                    else:
                        if self.times[0] <= 0:
                            self.times.pop(0)
                            self.phase = 0
                        else:
                            self.times[0] -= 100

            elif self.current:
                for i in self.contacts:
                    i.sms.append(self.current)
                    break
                else:
                    self.contacts.append(phone_contact(self.current[0], None, None, self.current))
                renpy.hide_screen("phone")
                renpy.show_screen("phone", self)
                self.open(self.current[0])
                self.current = None
                return 1


screen phone(c):
    timer .1 repeat True action Function(c.tick)
    vbox:
        align 0.0,0.0
        text str(len(c.times))
        text str(c.phase)
        if len(c.times):
            text str(c.times[0])

    if c.active:
        frame:
            xysize(600,900) padding(10,10) background "#222"
            frame: # Header
                ysize 80 xfill True yalign 0.0 background "#333b"
                if c.active.name:
                    text c.active.name
                else:
                    text _("Unknown")

            frame: # Main body
                background None padding (30,80,30,110) yfill True
                viewport id "phone_vp":
                    draggable True scrollbars None yinitial 1.0
                    xfill False
                    yfill False
                    yalign 1.0
                    frame:
                        padding(0,0) background None
                        vbox:
                            xfill True spacing 2
                            for n, i in enumerate(c.active.sms):
                                if isinstance(i, basestring):
                                    pass
                                else:
                                    if i[0] == c.id:
                                        if not n or not c.active.sms[n-1][0] == i[0]:
                                            null height 20
                                            hbox:
                                                xalign 1.0 spacing 0
                                                frame:
                                                    style "phone_right" xoffset 64
                                                    text i[1] color "#000"
                                                add "phone Aya" yalign 0.0
                                        else:
                                            frame:
                                                xalign 1.0
                                                style "phone_right_1"
                                                text i[1] color "#000"

                                    else:
                                        if not n or not c.active.sms[n-1][0] == i[0]:
                                            null height 20
                                            hbox:
                                                xalign 0.0 spacing 0
                                                add "phone RiRin" yalign 0.0
                                                frame:
                                                    style "phone_left" xoffset -64
                                                    text i[1] color "#000"
                                        else:
                                            frame:
                                                xalign 0.0
                                                style "phone_left_1"
                                                text i[1] color "#000"

            vbox: # Input
                yalign 1.0 spacing 0
                if c.current:
                    if c.phase == 1:
                        text "{} is typing...".format(c.active.name) size 15 xalign 0.0

                frame:
                    background "#333b" padding 10,10 xfill True
                    has hbox
                    xfill True
                    if c.typing:
                        frame:
                            xsize 420 padding 0,0 background None
                            text c.typing xalign 0.0
                    else:
                        text "Type text message..." xalign 0.0
                    button:
                        xalign 1.0 ysize 62 background "#222"
                        text "Send"





    # if c.choose:
    #     vbox:
    #         for i in c.choose:
    #             button:
    #                 xsize 600
    #                 text i
    #                 action Function(c.set_msg, i)




style phone_right:
    background Frame(im.Flip("phone/frm0.png",True), 10,20,76,10)
    padding(32,12,96,12)
    yminimum 64
    xmaximum 500

style phone_left:
    background Frame("phone/frm0.png", 76,20,10,10)
    padding(96,12,32,12)
    yminimum 64
    xmaximum 500
style phone_right_1:
    background Frame(im.Flip("phone/frm1.png",True), 10,20,76,10)
    padding(32,12,96,12)
    yminimum 64
    xmaximum 500
style phone_left_1:
    background Frame("phone/frm1.png", 76,20,10,10)
    padding(96,12,32,12)
    yminimum 64
    xmaximum 500